// Code generated by "enumer -type=VersionStatus -json -text -yaml -sql"; DO NOT EDIT.

//
package versionStatuses

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _VersionStatusName = "CurrentAheadOfLatestBehindLatest"

var _VersionStatusIndex = [...]uint8{0, 7, 20, 32}

func (i VersionStatus) String() string {
	if i < 0 || i >= VersionStatus(len(_VersionStatusIndex)-1) {
		return fmt.Sprintf("VersionStatus(%d)", i)
	}
	return _VersionStatusName[_VersionStatusIndex[i]:_VersionStatusIndex[i+1]]
}

var _VersionStatusValues = []VersionStatus{0, 1, 2}

var _VersionStatusNameToValueMap = map[string]VersionStatus{
	_VersionStatusName[0:7]:   0,
	_VersionStatusName[7:20]:  1,
	_VersionStatusName[20:32]: 2,
}

// VersionStatusString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func VersionStatusString(s string) (VersionStatus, error) {
	if val, ok := _VersionStatusNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to VersionStatus values", s)
}

// VersionStatusValues returns all values of the enum
func VersionStatusValues() []VersionStatus {
	return _VersionStatusValues
}

// IsAVersionStatus returns "true" if the value is listed in the enum definition. "false" otherwise
func (i VersionStatus) IsAVersionStatus() bool {
	for _, v := range _VersionStatusValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for VersionStatus
func (i VersionStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for VersionStatus
func (i *VersionStatus) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("VersionStatus should be a string, got %s", data)
	}

	var err error
	*i, err = VersionStatusString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for VersionStatus
func (i VersionStatus) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for VersionStatus
func (i *VersionStatus) UnmarshalText(text []byte) error {
	var err error
	*i, err = VersionStatusString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for VersionStatus
func (i VersionStatus) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for VersionStatus
func (i *VersionStatus) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = VersionStatusString(s)
	return err
}

func (i VersionStatus) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *VersionStatus) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := VersionStatusString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
